fl

{
PropForth 5.5(DevKernel)
 Thermal printer GY-EH601(basic is same as CSM-A2-T)
   RS232 115200baud
   
2018/10/01 11:07:18

                          ThermalPrinter
                          GY-EH601(not TTL-level)
P9(Rx)  ---- LevlShift ----- Tx
P10(Tx) ---- LevlShift ----- Rx
P0 --------- LevlShift ----- RTS(signal pulled out from board)  



RS232 115200bps  Noparity Stopbit1
time ------------------------------------------------------------>>
-------       ---------                               ------------
       |     |         |                             |
       |     |         |                             | 
        -----           -----------------------------
 idle   start bit0 bit1 bit2 bit3 bit4 bit5 bit6 bit7 stop  stop   idle
         bit                                           bit
       (always "0")                                  (always "1")


                 Prop plug
                -------------
P26(Tx) -------|RX           |     115200bps
P27(Rx) -------|TX           |-----------------------PC COM5 (Processing)
               |RES          | USB
GND -----------|Vss          |
                -------------

}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 

\ Priner command
wvariable LF -2 allot 1 c, 0 c, h0A c,
{
\ wvariable HT -2 allot 1 c, 0 c, h09 c,                 \ No operation
\ wvariable FF -2 allot 1 c, 0 c, h0C c,                 \ Same as LF
wvariable ESC_J -2 allot 2 c, 1 c, h1B c, h4A c,
wvariable ESC_FF -2 allot 2 c, 0 c, h1B c, h0C c,
wvariable ESC_d -2 allot 2 c, 1 c, h1B c, h64 c,
wvariable ESC_= -2 allot 2 c, 1 c, h1B c, h3D c,
\ Line spacing setting command
wvariable ESC_2 -2 allot 2 c, 0 c, h1B c, h32 c,
wvariable ESC_3 -2 allot 2 c, 1 c, h1B c, h33 c,
wvariable ESC_a -2 allot 2 c, 1 c, h1B c, h61 c, 
wvariable GS_L -2 allot 2 c, 2 c, h1D c, h4C c,
wvariable ESC_$ -2 allot 2 c, 2 c, h1B c, h24 c,
wvariable ESC_B -2 allot 2 c, 1 c, h1B c, h42 c,
\ Character command
wvariable ESC_! -2 allot 2 c, 1 c, h1B c, h21 c,
wvariable GS_! -2 allot 2 c, 1 c, h1D c, h21 c,          
\ wvariable ESC_E -2 allot 2 c, 1 c, h1B c, h45 c,          \ No operation
wvariable ESC_SP -2 allot 2 c, 1 c, h1B c, h20 c,
wvariable ESC_S0 -2 allot 2 c, 0 c, h1B c, h0E c,
wvariable ESC_DC4 -2 allot 2 c, 0 c, h1B c, h14 c,
wvariable ESC_{ -2 allot 2 c, 1 c, h1B c, h7B c,
wvariable GS_B -2 allot 2 c, 1 c, h1D c, h42 c,
\ wvariable ESC_- -2 allot 2 c, 1 c, h1B c, h2D             \ No operation
wvariable ESC_% -2 allot 3 c, 0 c, h1B c, h25 c, 1 c,
wvariable ESC_& -2 allot 2 c, 4 c, h1B c, h26 c,
wvariable ESC_? -2 allot 3 c, 0 c, h1B c, h25 c, 0 c,
wvariable ESC_R -2 allot 2 c, 1 c, h1B c, h52 c,
wvariable ESC_t -2 allot 2 c, 1 c, h1B c, h74 c,
\ Bit Image command
wvariable ESC_* -2 allot 2 c, 3 c, h1B c, h2A c,
wvariable GS_/ -2 allot 2 c, 1 c, h1D c, h2F c,
wvariable GS_* -2 allot 2 c, 2 c, h1D c, h2A c,
wvariable GS_v -2 allot 3 c, 5 c, h1D c, h76 c, 0 c,
}
wvariable DC2_* -2 allot 2 c, 2 c, h12 c, h2A c,
{
wvariable DC2_V -2 allot 2 c, 2 c, h12 c, h56 c,
wvariable DC2_v -2 allot 2 c, 2 c, h12 c, h76 c,
\  Key control command
wvariable ESC_c -2 allot 3 c, 1 c, h1B c, h63 c, h35 c,
}
\ Init command
wvariable ESC_@ -2 allot 2 c, 0 c, h1B c, h40 c,
\ Status command
{
wvariable ESC_v -2 allot 2 c, 0 c, h1B c, h76 c,
wvariable GS_a -2 allot 2 c, 0 c, h1D c, h61 c,
wvariable ESC_u -2 allot 2 c, 0 c, h1B c, h75 c,
\ Bar code command
wvariable GS_H -2 allot 2 c, 1 c, h1D c, h48 c,
wvariable GS_h -2 allot 2 c, 1 c, h1D c, h68 c,
wvariable GS_x -2 allot 2 c, 1 c, h1D c, h78 c,
wvariable GS_w -2 allot 2 c, 1 c, h1D c, h77 c,
wvariable GS_k_1 -2 allot 2 c, 1 c,
wvariable GS_k_2 -2 allot 2 c, 2 c,
}
\ Control parameter command
wvariable ESC_7 -2 allot 2 c, 3 c, h1B c, h37 c,
\ wvariable ESC_8 -2 allot 2 c, 1 c, h1B c, h38 c,
wvariable DC2_# -2 allot 2 c, 1 c, h12 c, h23 c,
\ wvariable DC2_T -2 allot 2 c, 0 c, h12 c, h54 c,

\ serial for PropForth<-->ThermalPrinter
9 wconstant Rx
d10 wconstant Tx
0 wconstant RTS
RTS >m constant RTSm

\ serial for PropForth<-->Processing
d27 wconstant ProcessRx
d26 wconstant ProcessTx
d28800 constant baud2/4    \ 115200/4

\ ==================================================================
\ Variables
\ ================================================================== 
wvariable inchar1
wvariable inchar2

\ ==================================================================
\ Main
\ ================================================================== 
\ Start up serial-communication(ThermalPrinter)
\ This need to execute when staring serial-communication at first
\ ( -- )
: initSerial
c" Tx Rx baud2/4 serial" 4 cogx     \ Start serial on cog5
d100 delms
inchar1 4 cogio 2+ W!               \ Set output of cog5 to inchar1
h100 inchar1 W!                     \ Clear inchar1
1 4 sersetflags
;

\ Stop Serial communication
\ This need to execute when finishing serial-communication at last
\ ( -- )
: stopSerial 0 4 cogio 2+ W! 4 cogreset ;

\ Transmit data[1byte]
\ ( n1 -- )  n1:transmitting byte
: Transmit
begin 4 cogio W@ h100 and until    \ Wait until input for serial-cog is under ready-state
4 cogio W!                         \ Write data to cog5's input
;

\ Receive data and save them in free area
\ ( n1 -- n2 ) n1:repeat number  n2:last addres+1 of free area 
: Receive
here W@ swap
0 do
     begin inchar1 W@ h100 and 0= until       \ Wait until output for serial-cog is under ready-state
     inchar1 W@ over C!                       \ Save output-data of cog5 to free area
     h100 inchar1 W!                          \ Clear inchar1
     1+                                      \ Increment free space address
loop
;

\ Send command to ThermalPrinter
\ ( nn-nm n1 -- )   nn-nm:data if needed  n1:command 
: prtcmd
dup                     
C@ over 2+ swap
0 do dup C@ Transmit 1+ loop drop            \ Serial out command
1+ C@ dup 0<>
if
     0 do Transmit loop                       \ Serial out data
else
     drop
then
;

\ -----------------------------------------------
\ Word for Thermal Printer
\ -----------------------------------------------
\ Initialize printer ( -- )
: init_prt ESC_@ prtcmd ;
\ Carrige return ( -- )
: linefeed LF prtcmd ;
{
\ code437 ( -- )
: code437 0 ESC_t prtcmd ;
\ code850 ( -- )
: code850 1 ESC_t prtcmd ;
\ Set bold font ( -- )
: bold_on 1 ESC_SP prtcmd ;
\ Cansel bold font ( -- )
: bold_off 0 ESC_SP prtcmd ;
\ Set double-width ( -- )
: double_width_on ESC_S0 prtcmd ;
\ Cansel double-width ( -- )
: double_width_off ESC_DC4 prtcmd ;
\ Set character updown ( -- )
: updown_on 1 ESC_{ prtcmd ;
\ Cansel character updown ( -- )
: updown_off 0 ESC_{ prtcmd ;
\ Set reverse mode  ( -- )
: reverse_prt_on 1 GS_B prtcmd ;
\ Cansel reverse mode ( -- )
: reverse_prt_off 0 GS_B prtcmd ;
\ Set font size  ( n -- ) n:font size  7<n<24
: font_size GS_! prtcmd ;
\ Set start-position to left
: left 0 ESC_a prtcmd ;
\ Set start-position to center
: center 1 ESC_a prtcmd ;
\ Set start-position to right
: right 2 ESC_a prtcmd ;
\ TAB (6 blank char)
: prt_tab 5 ESC_B prtcmd ;

\ --- ESC ! ---
\ Set small character
: small_char 1 ESC_! prtcmd ;
\ Set emphasized mode
: emphasize_char 8 ESC_! prtcmd ;
\ Set Double height mode
: heightX2_on h10 ESC_! prtcmd ;
\ Set Double width mode
: widthX2_on h20 ESC_! prtcmd ;
\ Set underline
: underline_on h80 ESC_! prtcmd ;
\ Cancel ESC !
: ESC_!_off 0 ESC_! prtcmd ;
}

\ Receive print-data 
\ ( n1 -- )  n1:reciving data number
: recieveData 
here W@
swap 0 do                               \ ( [here] )
     begin inchar2 W@ h100 <> until
     inchar2 W@ over C!
     h100 inchar2 W!                    \ Set inchar2 ready to receive next char
     1+                                 \ ( [here]+1 )
loop
drop
;

\ Wait until RTS is loe
\ ( -- )  
: Ready? 1 delms begin RTSm ina COG@ and 0= until ;
 
\ Print bitmap
\ ( -- ) 
: dotPrint
here W@
2 0 do
     d48 d128 DC2_* prtcmd  d10 delms
     d128 0 do
          d48 0 do 
               dup C@ invert hFF and Transmit 1 + 
               Ready?
          loop
          d10 delms 
     loop 
loop
drop
;

\ Receive bit-data to print(24576byte:384x512dots)
\ ( -- )
: monochroPrint
\ Initialize ThermalPrinter
initSerial
init_prt 
                  
d40 d100 5 ESC_7 prtcmd                 \ n1(max heating dots)=5 n2(Heating Time)=50 n3(Heatin Interval)=40 
hFF DC2_# prtcmd                        \ Change density

\ Initialize serial-communication to Processing
     \ if this bit is 0, CR is transmitted as CR LF
     \ if this bit is 1, CR is transmitted as CR
 1 5 sersetflags
\ pin 26 tx, pin 27 rx  115200baud  
c" 26 27 baud2/4 serial" 5 cogx
d10 delms
5 cogio 2+ W@                           \ Put output ptr of cog5 on stack
inchar2 5 cogio 2+ W!                    \ Set output ptr of cog5 to inchar2
io 2+ W@                                \ Put output ptr of current cog on stack
5 cogio io 2+ W!                        \ Set output ptr of current cog to input ptr of cog 5
h100 inchar2 W!

\ Receive 1st print-data
d12288 recieveData
dotPrint
                                     
\ Request next print-data
d60 emit                             
   
\ Receive 2nd print-data   
d12288 recieveData
dotPrint 
                                           
\ Request next print-data
d60 emit                             
   
\ Receive 2nd print-data   
d12288 recieveData
dotPrint 

here W@ d12288 hFF fill        
                                   
\ Request next print-data
d60 emit                              

\ Receive 3rd print-data   
d2496 recieveData
dotPrint 

\ Restore output ptr for current cog 
io 2+ W!
\ Restore output ptr for cog 5
5 cogio 2+ W!   

\ Read out until read-buffer is empty
begin 
     inchar2 W@ h100 =
     if
          1
     else
          h100 inchar2 W! 0
     then
until     
5 cogreset
d100 delms
linefeed linefeed

d500 delms
stopSerial
;
: test
\ Initialize ThermalPrinter
initSerial
init_prt 
                  
d40 d100 5 ESC_7 prtcmd                 \ n1(max heating dots)=5 n2(Heating Time)=50 n3(Heatin Interval)=40 
hFF DC2_# prtcmd                        \ Change density
dotPrint
d100 delms
linefeed linefeed

d500 delms
stopSerial
;
